#!/usr/bin/bash

#now=`date '+%Y-%m-%d-%H-%M-%S'`
log=/root/SPC/spc2/audit/spc2_audit.out
cd /root/SPC/spc2

# Source environment variables
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : SPC2 Start. Sourcing environment variables." > $log
echo "--------------------------------------------------------------" >> $log
source /root/SPC/spc2/spc2_env
pdsh -R ssh -w vxhost-[1-8] 'uptime' | sort >> $log
echo " " >> $log

# Array Information
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : Array Information." >> $log
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" >> $log
ssh root@bolt46 'bash -s' < array_info.sh >> $log
echo " " >> $log
sleep 5

# Run pre-fill on all hosts
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : Starting Pre-fill on all volumes." >> $log
echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++" >> $log
/root/vdbench/vdbench -f pre_fill.par -o 1.pre_fill_results
echo " " >> $log
pdsh -R ssh -w vxhost-[1-8] 'uptime' | sort >> $log

# Array Information
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : Array Information." >> $log
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" >> $log
ssh root@bolt46 'bash -s' < array_info.sh >> $log
echo " " >> $log
sleep 5

# Start RemoteStart on all 7 remote hosts if not started
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : Starting RemoteStart background process on all remote hosts." >> $log
echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" >> $log

count=`pdsh -R ssh -w vxhost-[2-8] "ps -ef | grep -i 'bash -c /root/SPC/spc2/vdb_remotestart.sh'" |grep -v grep | wc -l`
if ((count==7)) 
then
        echo "Remotestart is running on $count remote hosts. Proceeding with next step." >> $log
else
	echo "Please start Remotestart on remote hosts. On master host, run pdsh -R ssh -w vxhost-[2-8] '/root/SPC/spc2/vdb_remotestart.sh'" >> $log
	exit 1
fi
echo " " >> $log

# SPC2 Init Process
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : SPC2 Init process." >> $log
echo "++++++++++++++++++++++++++++++++++++++++++" >> $log
./spc2 -f large_file_processing.par -init -o 2.Init_results
echo " " >> $log
sleep 5

# Array Information
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : Array Information." >> $log
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" >> $log
ssh root@bolt46 'bash -s' < array_info.sh >> $log
echo " " >> $log
sleep 5

# SPC2 Large File Process
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : SPC2 Large File process." >> $log
echo "++++++++++++++++++++++++++++++++++++++++++++++++" >> $log
./spc2 -f large_file_processing.par -o 3.lfp_results
echo " " >> $log
sleep 5

# Array Information
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : Array Information." >> $log
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" >> $log
ssh root@bolt46 'bash -s' < array_info.sh >> $log
echo " " >> $log
sleep 5

# SPC2 Large Database Query Process
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : SPC2 Large Database Query process." >> $log
echo "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" >> $log
./spc2 -f large_db_query.par -o 4.ldbq_results
echo " " >> $log
sleep 5

# Array Information
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : Array Information." >> $log
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" >> $log
ssh root@bolt46 'bash -s' < array_info.sh >> $log
echo " " >> $log
sleep 5

# SPC2 Video On Demand Delivery Process
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : SPC2 Video On Demand Delivery Process." >> $log
echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" >> $log
./spc2 -f  video_on_demand.par -o 5.vod_results
echo " " >> $log
sleep 5

# Array Information
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : Array Information." >> $log
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" >> $log
ssh root@bolt46 'bash -s' < array_info.sh >> $log
echo " " >> $log
sleep 5

# SPC2 Persistence Write Process
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : SPC2 Persistence Write Process." >> $log
echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++" >> $log
./spc2 -f persistense_write.par -o 6.persistence_write
echo " " >> $log
sleep 5

# Array Information
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : Array Information." >> $log
echo "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~" >> $log
ssh root@bolt46 'bash -s' < array_info.sh >> $log
echo " " >> $log
sleep 5

# SPC2 Reboot of Storage and remote hosts
now=`date '+%Y-%m-%d %H:%M:%S'`
echo "$now : SPC2 Storage and Remote Hosts Reboot." >> $log
echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++" >> $log
echo "Reboot the storage and Host machines.." >> $log
pdsh -R ssh -w vxhost-[1-8] 'uptime' | sort >> $log
echo " " >> $log

# Backup log

now=`date '+%Y-%m-%d-%H-%M-%S'`
cp $log /root/SPC/spc2/audit/spc2_audit_$now.out
